VERSION 5.00
Begin VB.Form MainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Winamp Hotkey Ex"
   ClientHeight    =   3960
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3405
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "MainForm.frx":0000
   MaxButton       =   0   'False
   ScaleHeight     =   3960
   ScaleWidth      =   3405
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer HookTimer 
      Enabled         =   0   'False
      Interval        =   10000
      Left            =   120
      Top             =   600
   End
   Begin VB.Timer DetectTimer 
      Interval        =   3000
      Left            =   120
      Top             =   120
   End
   Begin VB.Label Label12 
      Caption         =   "Fast Forward: Ctrl + Right"
      Height          =   255
      Left            =   360
      TabIndex        =   9
      Top             =   3000
      Width           =   2655
   End
   Begin VB.Label Label11 
      Caption         =   "Fast Rewind: Ctrl + Left"
      Height          =   255
      Left            =   360
      TabIndex        =   8
      Top             =   2640
      Width           =   2655
   End
   Begin VB.Label Label10 
      Caption         =   "Toggle Playlist Shuffle: Shift + F6"
      Height          =   255
      Left            =   360
      TabIndex        =   7
      Top             =   1920
      Width           =   2655
   End
   Begin VB.Label Label9 
      Caption         =   "Toggle Playlist Repeat: Shift + F5"
      Height          =   255
      Left            =   360
      TabIndex        =   6
      Top             =   1560
      Width           =   2655
   End
   Begin VB.Label Label6 
      Caption         =   "Save Song Title Hotkey: Shift + F10"
      Height          =   255
      Left            =   360
      TabIndex        =   5
      Top             =   2280
      Width           =   2655
   End
   Begin VB.Label Label5 
      Alignment       =   2  'Center
      Caption         =   "Winamp Not Running!"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   3480
      Width           =   3015
   End
   Begin VB.Label Label4 
      Caption         =   "Prev Song Hotkey: Shift + F4"
      Height          =   255
      Left            =   360
      TabIndex        =   3
      Top             =   1200
      Width           =   2655
   End
   Begin VB.Label Label3 
      Caption         =   "Next Song Hotkey: Shift + F3"
      Height          =   255
      Left            =   360
      TabIndex        =   2
      Top             =   840
      Width           =   2655
   End
   Begin VB.Label Label2 
      Caption         =   "Stop Hotkey: Shift + F2"
      Height          =   255
      Left            =   360
      TabIndex        =   1
      Top             =   480
      Width           =   2655
   End
   Begin VB.Label Label1 
      Caption         =   "Play/Pause Hotkey: Shift + F1"
      Height          =   255
      Left            =   360
      TabIndex        =   0
      Top             =   120
      Width           =   2655
   End
   Begin VB.Menu SystrayMenu 
      Caption         =   "Systray Menu"
      Visible         =   0   'False
      Begin VB.Menu OpenMenu 
         Caption         =   "&Show"
      End
      Begin VB.Menu Blank1 
         Caption         =   "-"
      End
      Begin VB.Menu SettingMenu 
         Caption         =   "Settings"
         Begin VB.Menu RunOnStartupMenu 
            Caption         =   "&Run On Startup"
         End
      End
      Begin VB.Menu Blank2 
         Caption         =   "-"
      End
      Begin VB.Menu CloseMenu 
         Caption         =   "&Close"
      End
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Const WM_MOUSEMOVE = &H200
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_LBUTTONDBLCLK = &H203
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205
Private Const WM_RBUTTONDBLCLK = &H206
Private Const WM_MBUTTONDOWN = &H207
Private Const WM_MBUTTONUP = &H208
Private Const WM_MBUTTONDBLCLK = &H209
Public SysTray As New SystrayIcon

Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long

Private Sub CloseMenu_Click()
    Unload Me
End Sub

Private Sub DetectTimer_Timer()
Dim hWnd_Winamp As Long
    hWnd_Winamp = FindWindow("Winamp v1.x", vbNullString)
    If hWnd_Winamp Then
        Label5.Caption = "Winamp Is Running!"
        HookTimer.Enabled = True
        HookTimer_Timer
    Else
        Label5.Caption = "Winamp Not Running!"
        HookTimer.Enabled = False
    End If
End Sub

Private Sub Form_Load()
Dim RegData As String
    SysTray.PopUpMessage = Caption + " v" & App.Major & "." & App.Minor & _
    IIf(App.Revision = 0, "", "." & App.Revision) & " By Jason's PC Software"
    SysTray.Initialize hWnd, Icon, SysTray.PopUpMessage
    SysTray.ShowIcon
    RegData = GetRegString(HKEY_LOCAL_MACHINE, AppRegRoot, "RunOnStartup")
    If RegData = "True" Or RegData = "False" Then RunOnStartupMenu.Checked = RegData
    If LCase(Command) = "-startup" Then WindowState = vbMinimized
End Sub


Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim msgCallBackMessage As Long
    msgCallBackMessage = X / Screen.TwipsPerPixelX
    Select Case msgCallBackMessage
        Case WM_MOUSEMOVE
            SysTray.TipText = SysTray.PopUpMessage
        Case WM_LBUTTONDBLCLK
            If OpenMenu.Enabled = False Then Exit Sub
            AlwaysOnTop Me, True
            Visible = True
            AlwaysOnTop Me, False
            OpenMenu.Caption = "&Hide"
        Case WM_RBUTTONDOWN
            If OpenMenu.Enabled = False Then Exit Sub
            If Visible = False Then OpenMenu.Caption = "&Show"
            If Visible = True Then OpenMenu.Caption = "&Hide"
            PopupMenu SystrayMenu, , , , OpenMenu
    End Select
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode = 0 Or UnloadMode = 3 Then
        WindowState = vbMinimized
        Cancel = True
    End If
End Sub

Private Sub Form_Resize()
    If WindowState = vbMinimized Then
        Visible = False
        WindowState = 0
    End If
End Sub


Private Sub Form_Unload(Cancel As Integer)
    SysTray.HideIcon
    UnSubclass
    End
End Sub


Private Sub HookTimer_Timer()
    RemoveHook
    SetHook AppWnd
End Sub


Private Sub OpenMenu_Click()
    If Not Visible Then AlwaysOnTop Me, True
    Visible = Not Visible
    AlwaysOnTop Me, False
End Sub


Private Sub RunOnStartupMenu_Click()
    RunOnStartupMenu.Checked = Not RunOnStartupMenu.Checked
    SaveRegString HKEY_LOCAL_MACHINE, AppRegRoot, "RunOnStartup", CStr(RunOnStartupMenu.Checked)
    If RunOnStartupMenu.Checked Then
        SaveRegString HKEY_LOCAL_MACHINE, "Software\Microsoft\Windows\CurrentVersion\Run\", "Winamp Hotkey Ex", """" + LCase(App.Path + IIf(Right(App.Path, 1) <> "\", "\", "")) + App.EXEName + ".exe"" -startup"
    Else
        DeleteValue HKEY_LOCAL_MACHINE, "Software\Microsoft\Windows\CurrentVersion\Run\", "Winamp Hotkey Ex"
    End If
End Sub


